mcast6-queryfld05 6.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209
  1. #!/bin/sh
  2. ################################################################################
  3. ## ##
  4. ## Copyright (c) International Business Machines Corp., 2006 ##
  5. ## ##
  6. ## This program is free software; you can redistribute it and#or modify ##
  7. ## it under the terms of the GNU General Public License as published by ##
  8. ## the Free Software Foundation; either version 2 of the License, or ##
  9. ## (at your option) any later version. ##
  10. ## ##
  11. ## This program is distributed in the hope that it will be useful, but ##
  12. ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
  13. ## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
  14. ## for more details. ##
  15. ## ##
  16. ## You should have received a copy of the GNU General Public License ##
  17. ## along with this program; if not, write to the Free Software ##
  18. ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA ##
  19. ## ##
  20. ## ##
  21. ################################################################################
  22. #
  23. # File:
  24. # mcast6-queryfld05
  25. #
  26. # Description:
  27. # Verify that the kernel is not crashed when joining joining plural IPv6
  28. # multicast groups on separate socket, then receiving a large number of
  29. # Multicast Address Specific Query
  30. #
  31. # Setup:
  32. # See testcases/network/stress/README
  33. #
  34. # Author:
  35. # Mitsuru Chinen <mitch@jp.ibm.com>
  36. #
  37. # History:
  38. # May 7 2006 - Created (Mitsuru Chinen)
  39. #
  40. #-----------------------------------------------------------------------
  41. # Uncomment line below for debug output.
  42. #trace_logic=${trace_logic:-"set -x"}
  43. $trace_logic
  44. # The test case ID, the test case count and the total number of test case
  45. TCID=mcast6-queryfld05
  46. TST_TOTAL=1
  47. TST_COUNT=1
  48. export TCID
  49. export TST_COUNT
  50. export TST_TOTAL
  51. # Make sure the value of LTPROOT
  52. LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
  53. export LTPROOT
  54. # Check the environmanet variable
  55. . check_envval || exit $TST_TOTAL
  56. # Dulation of the test [sec]
  57. NS_DURATION=${NS_DURATION:-3600} # 1 hour
  58. # Number of the multicast to join
  59. MCASTNUM_NORMAL=${MCASTNUM_NORMAL:-20}
  60. # The number of the test link where tests run
  61. LINK_NUM=${LINK_NUM:-0}
  62. # Network portion of the IPv6 address
  63. NETWORK_PART="fec0:1:1:1"
  64. # Host portion of the IPv6 address
  65. LHOST_HOST_PART=":2" # local host
  66. RHOST_HOST_PART=":1" # remote host
  67. # Prefix of the Multicast Address
  68. MCAST_ADDR_PREFIX=ff0e:
  69. #-----------------------------------------------------------------------
  70. #
  71. # Function: do_cleanup
  72. #
  73. # Description:
  74. # Recover the system configuration
  75. #
  76. #-----------------------------------------------------------------------
  77. do_cleanup()
  78. {
  79. # Make sure to kill the multicast receiver and sender
  80. killall -SIGHUP ns-mcast_join >/dev/null 2>&1
  81. $LTP_RSH $RHOST killall -SIGHUP ns-icmpv6_sender >/dev/null 2>&1
  82. # Clean up each interface
  83. initialize_if lhost ${LINK_NUM}
  84. initialize_if rhost ${LINK_NUM}
  85. }
  86. #-----------------------------------------------------------------------
  87. #
  88. # Function: do_setup
  89. #
  90. # Description:
  91. # Configure the ssystem for the test
  92. #
  93. #-----------------------------------------------------------------------
  94. do_setup()
  95. {
  96. # Initialize the system configuration
  97. do_cleanup
  98. # Call do_cleanup function before exit
  99. trap do_cleanup 0
  100. # name of interface of the local/remote host
  101. lhost_ifname=`get_ifname lhost $LINK_NUM`
  102. if [ $? -ne 0 ]; then
  103. tst_resm TBROK "Failed to get the interface name at the local host"
  104. exit $TST_TOTAL
  105. fi
  106. rhost_ifname=`get_ifname rhost $LINK_NUM`
  107. if [ $? -ne 0 ]; then
  108. tst_resm TBROK "Failed to get the interface name at the remote host"
  109. exit $TST_TOTAL
  110. fi
  111. # Set IPv6 addresses to the interfaces
  112. add_ipv6addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
  113. if [ $? -ne 0 ]; then
  114. tst_resm TBROK "Failed to add any IP address at the local host"
  115. exit 1
  116. fi
  117. add_ipv6addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
  118. if [ $? -ne 0 ]; then
  119. tst_resm TBROK "Failed to add any IP address at the remote host"
  120. exit 1
  121. fi
  122. # IPv6 address of the local/remote host
  123. lhost_addr="${NETWORK_PART}:${LHOST_HOST_PART}"
  124. rhost_addr="${NETWORK_PART}:${RHOST_HOST_PART}"
  125. rhost_linklocal="fe80:${RHOST_HOST_PART}"
  126. # Make sure the connectvity
  127. check_icmpv6_connectivity $lhost_ifname $rhost_addr
  128. if [ $? -ne 0 ]; then
  129. tst_resm TBROK "There is no IPv6 connectivity."
  130. exit 1
  131. fi
  132. # Make sure the sysctl values
  133. sysctl -w net.ipv6.conf.all.force_mld_version=0 >/dev/null
  134. if [ $? -ne 0 ]; then
  135. tst_resm TBROK "Failed to set the sysctl value regarding multicast"
  136. exit $TST_TOTAL
  137. fi
  138. sysctl -w net.ipv6.conf.${lhost_ifname}.force_mld_version=0 >/dev/null
  139. sysctl -w net.ipv6.mld_max_msf=10 >/dev/null
  140. }
  141. #-----------------------------------------------------------------------
  142. #
  143. # Main
  144. #
  145. #
  146. # Test description
  147. tst_resm TINFO "Verify that the kernel is not crashed when joining $MCASTNUM_NORMAL IPv6 multicast groups on separate sockets, then receiving a large number of Multicast Address Specific Query in $NS_DURATION [sec]"
  148. do_setup
  149. # Run a multicast join tool
  150. ns-mcast_join -f 6 -I $lhost_ifname -n $MCASTNUM_NORMAL -p $MCAST_ADDR_PREFIX > /dev/null
  151. if [ $? -ne 0 ]; then
  152. tst_resm TBROK "Failed to start multicast joining tool Please check the environment"
  153. exit 1
  154. fi
  155. # Send MLD Multicast Address Specific Query from the remote host
  156. querier_num=0
  157. while [ $querier_num -lt $MCASTNUM_NORMAL ]; do
  158. # Define the multicast address
  159. if [ $querier_num -gt 65535 ]; then
  160. tst_resm TINFO "The number of the querier is less than 65535"
  161. break
  162. fi
  163. querier_num_hex=`printf "%x" $querier_num`
  164. mcast_addr=${MCAST_ADDR_PREFIX}:${querier_num_hex}
  165. $LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-icmpv6_sender -I $rhost_ifname -S $rhost_linklocal -m -D $mcast_addr -r 0 -t $NS_DURATION -b
  166. querier_num=`expr $querier_num + 1`
  167. done
  168. sleep $NS_DURATION
  169. #-----------------------------------------------------------------------
  170. #
  171. # Clean up
  172. #
  173. do_cleanup
  174. tst_resm TPASS "Test is finished successfully."
  175. exit 0